include "KXEVENT.INC"
ret			; jump back from include call

;-------------------------------------------------------------------------------
; draw a 3d rectangle
; ebx - top left corner (x shl 16 + y)
; ecx - bootom right corner (x shl 16 + y)
; edx - border color for taised or lowered (0x0 or 0xffffff)
; esi - border width
;-------------------------------------------------------------------------------
_kx_rect:
    call _kx_get_koord
    call _kx_adjust_size
_kx_draw_rect:
    mcall 38,<[_kx_xp],[_kx_xs]>,<[_kx_yp],[_kx_yp]>
    mcall   ,<[_kx_xp],[_kx_xp]>,<[_kx_yp],[_kx_ys]>
    xor edx,0xffffff
    mcall   ,<[_kx_xp],[_kx_xs]>,<[_kx_ys],[_kx_ys]>
    mcall   ,<[_kx_xs],[_kx_xs]>,<[_kx_yp],[_kx_ys]>

; a bevel mas be drawn with 2 lines, its border width is in esi
    cmp esi,0	      ; border width=0? so lets go home
    je	_kx_ready_rect
    add [_kx_xp],esi
    add [_kx_yp],esi
    sub [_kx_xs],esi
    sub [_kx_ys],esi
    mcall 38,<[_kx_xp],[_kx_xs]>,<[_kx_yp],[_kx_yp]>
    mcall   ,<[_kx_xp],[_kx_xp]>,<[_kx_yp],[_kx_ys]>
    xor edx,0xffffff
    mcall   ,<[_kx_xp],[_kx_xs]>,<[_kx_ys],[_kx_ys]>
    mcall   ,<[_kx_xs],[_kx_xs]>,<[_kx_yp],[_kx_ys]>
_kx_ready_rect:
ret

;-------------------------------------------------------------------------------
; the button right from listbox
_kx_lb:
    call _kx_inf
    call _kx_get_koord
    mov eax,14
    add [_kx_xs],eax
    call _kx_draw_rect
    add [_kx_xp],5
    add [_kx_yp],3
    mcall 4 ,<[_kx_xp],[_kx_yp]>,0,_kx_arrow,1
ret

;-------------------------------------------------------------------------------
; the input field
_kx_inf:
    call _kx_get_koord
    mcall 13,<[_kx_xp],[_kx_xs]>,<[_kx_yp],[_kx_ys]>
    mov esi,0
    mov edx,bsInner
    call _kx_rect
    pusha
    mov edx,1	      ; set bit 30 for an unvisible button
    shl edx,30
    mcall 8,<[_kx_xs],14>,<[_kx_yp],16>;
    popa
ret

;-------------------------------------------------------------------------------
; draw underline
_kx_uline:
    call _kx_get_koord
    add [_kx_yp],dword 10
    mov [_kx_lc],eax		   ; in eax we got the string length
    mov edi,[_kx_xp]
    mov [_kx_xs],edi
    imul eax,6
    add [_kx_xs],eax
    ; if the font is fsBold, we need some pixel more
    push edx		       ; save color
    and edx,0xf0000000
    shr edx,28

    imul edx,[_kx_lc]
    add [_kx_xs],edx
    mov edx,[_kx_lc]
    shr edx,2
    sub [_kx_xs],edx
    pop edx

  _kx_draw_uline:
    mcall 38,<[_kx_xp],[_kx_xs]>,<[_kx_yp],[_kx_yp]>
ret

;-------------------------------------------------------------------------------
; draw a horizontal pointed line
func _kx_draw_hpline
  _kx_hpline:
    mov ebx,[_kx_xp]
    mov ecx,[_kx_yp]
    mcall 1
    add [_kx_xp],3
    mov edi,[_kx_xp]
    cmp [_kx_xs],edi
    jg _kx_hpline
  ret
endf

;-------------------------------------------------------------------------------
; draw a vertical pointed line
func _kx_draw_vpline
  _kx_vpline:
    mov ebx,[_kx_xp]
    mov ecx,[_kx_yp]
    mcall 1
    add [_kx_yp],2
    mov edi,[_kx_yp]
    cmp [_kx_ys],edi
    jg _kx_vpline
  ret
endf

;-------------------------------------------------------------------------------
; draw pointed rectangle
func _kx_draw_prect
    mov edx,0		; we draw only black
;    call adjust_size
    push [_kx_yp]
    push [_kx_xp]
    push [_kx_xp]
    call _kx_draw_hpline
    call _kx_draw_vpline
    pop [_kx_xp]
    call _kx_draw_hpline
    pop [_kx_xp]
    pop [_kx_yp]
    call _kx_draw_vpline
  ret
endf

;-------------------------------------------------------------------------------
; set the focus to selected element
func _kx_set_focus
    call _kx_get_koord
    call _kx_adjust_size
    call _kx_draw_prect
  ret
endf

;-------------------------------------------------------------------------------
; the rect-paramters are defined as absolute start/end positions instead of
; start/size, so we make end:=end+start
func _kx_adjust_size
    mov eax,[_kx_xs]
    add eax,[_kx_xp]
    mov [_kx_xs],eax
    mov eax,[_kx_ys]
    add eax,[_kx_yp]
    mov [_kx_ys],eax
ret
endf

;-------------------------------------------------------------------------------
; extract koordinates for drawing, desc s. rect:
func _kx_get_koord
; extract coords
    mov edi,ebx
    shr ebx,16
    mov [_kx_xp],ebx
    shl ebx,16
    sub edi,ebx
    mov [_kx_xs],edi

    mov edi,ecx
    shr ecx,16
    mov [_kx_yp],ecx
    shl ecx,16
    sub edi,ecx
    mov [_kx_ys],edi
ret
endf

eh:
pusha

popa
ret


_kx_xp	   dd	   ?
_kx_xs	   dd	   ?
_kx_yp	   dd	   ?
_kx_ys	   dd	   ?
_kx_lc	   dd	   ?
_kx_arrow  db	   "v"